# TBasicShadowFeature Class Reference
[Base Classes for plugins]

Inheritance diagram for TBasicShadowFeature:

List of all members.

## Public Member Functions
virtual MCCOMErr MCCOMAPI | QueryInterface (const MCIID &riid, void **ppvObj)
virtual uint32 MCCOMAPI | AddRef ()
virtual MCCOMErr MCCOMAPI | BeginRenderFrame (I3DShLightsource *light)
virtual MCCOMErr MCCOMAPI | EndRenderFrame ()
virtual boolean MCCOMAPI | CalcShadow (ShadowIO &shadowIO, const LightingContext &lightingContext)

## Detailed Description

Basic Shadow Feature class. Derive from this for a default implementation of I3DExShadowFeature

See also:
  I3DExShadowFeature

## Member Function Documentation

virtual uint32 MCCOMAPI TBasicShadowFeature::AddRef | ( |  | ) | `[inline, virtual]`

Increments the reference count of the object

Reimplemented from TBasicRenderFeature.

virtual MCCOMErr MCCOMAPI TBasicShadowFeature::BeginRenderFrame | ( | I3DShLightsource * | light | ) | `[virtual]`

Called by the shell at the beginning of the rendering of each frame. This fonction can be used to calculate a cache (shadow buffer for instance)

Parameters:

  | light | : the light on which the shadow feature is applied

Implements I3DExShadowFeature.

virtual boolean MCCOMAPI TBasicShadowFeature::CalcShadow | ( | ShadowIO & | shadowIO,
|  | const LightingContext & | lightingContext |
| ) |  |  | `[virtual]`

Calculate the light reaching a point from a light source

Note:
  This function must be SMP compliant (= reentrant) !

Parameters:

  | shadowIO | : a structure containing all the parameters of this call
  | lightingContext | : info about the point being lit

True if a shadow was cast

Implements I3DExShadowFeature.

virtual MCCOMErr MCCOMAPI TBasicShadowFeature::EndRenderFrame | ( |  | ) | `[virtual]`

Called by the shell at the end of the rendering of each frame. This fonction can be used to delete caches.

Implements I3DExShadowFeature.

virtual MCCOMErr MCCOMAPI TBasicShadowFeature::QueryInterface | ( | const MCIID & | riid,
|  | void ** | ppvObj |
| ) |  |  | `[virtual]`

Check if the object supports a given interface and returns a pointer to that interface if it does. Note that QueryInterface will increment the reference count of the object by one if the interface is found.

Parameters:

  | riid | GUID of the interface
  | ppvObj | A pointer to the pointer being returned.

Reimplemented from TBasicRenderFeature.

The documentation for this class was generated from the following file:

- BasicRenderFeature.h